#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Created on Thu Jun 29 16:04:01 2017

@author: Oana
@email: oana.dumitru@nyu.edu
"""
############################################################################## 

##############################################################################
# Function Definitions

# function to import the excel file by each column

def take_excel(column, ibi_series):
    # need to change the starting row (here it is 29) to where you data begins
    for row in range (29, sheet.nrows):
        try:
            ibi_series.append(str(sheet.cell(row,column)))
        except: 
            ibi_series.append(0)
    return ibi_series

# function to remove empty values from Excel
# no need to change this
def remove_empty(ibi_series):
    while "empty:u''" in ibi_series:
        ibi_series.remove("empty:u''")
    return ibi_series

# function to turn strings into integers
def turn_to_integer(ibi_series):
    for i in range(len(ibi_series)):
        try:
            float_ibi = float(ibi_series[i][7:])
            ibi_series[i] = float_ibi
        except:
            ibi_series[i] = 0


def downsample(series, x, filename):
    
    # change the structure of your filename if you want it to be different 
    # here the file name will have the format IBI_201_01, IBI_201_02, etc. 
    filename = filename + "_IBI" + "_0" + str(x) +  ".txt"
    
    ##########################################################################
    # From here on, do not change the code. 
    ##########################################################################
    
    new_sheet = open(filename, 'w')

    # make a copy
    newdata = series 
    ibi = []
    
     # Create the sum series
    for i in range(1,len(newdata)):
        newdata[i] += float(newdata[i-1])
        
    # initalize i as 0
    i = 0 
    while i != len(newdata):        
        second = newdata[i]//1000
        
        # make sure there is a previous second 
        if i != 0:
            previous_second = newdata[i-1]//1000
        else:
            previous_second = 0
            
        # if the first beat jumps trough second 0, make second 0 equal to the beat 
        if i == 0 and second == 1:
            val = newdata[i]
            ibi += [val]
            
        
        # if you are not on the last number 
        if i != len(newdata) - 1: 
            next_second = newdata[i + 1]//1000
            
            # does the next beat fall into the same second?
            if next_second == second:
                
                # determine the weights 
                a = (newdata[i] - second*1000)/float(1000)
                b = (newdata[i + 1] - newdata[i])/float(1000)
                c = ((second + 1) * 1000 - newdata[i + 1])/float(1000)
                
                # determine the beats 
                 
                # if it's the first beat, then use that as the length of the beat
                if i == 0:
                    k = newdata[i]
                    
                # if it's not, need to subtract the previous beat from it 
                else:
                    k = newdata[i] - newdata[i - 1]
                
                # the second beat is obtained by subtracting the current one 
                l = newdata[i + 1] - newdata[i]
                
                # if on the second to last beat, consider the next next beat as 0 
                if i == len(newdata) -  2:
                    m = 0
                # if not, this is the next, next beat 
                else:
                    m = newdata[i + 2] - newdata[i + 1]
                
                val = a * k + b * l + c * m
                # compute the IBI for that second 
                
                # determine if this beat jumped over 2 seconds instead of 1 
                if second == previous_second + 2 and i != 0:
                    val2 = newdata[i] - newdata[i - 1]
                    ibi += [val2]

                ibi += [val]
#                
                # delete the initial second 
                i += 2
                
            # if it doesn't fall into the same second
            # determine the weights 
            else:

                a = (newdata[i] - second*1000)/float(1000)
                b = 1 - a
                
                if i == 0:
                    k = newdata[i]
                else:
                    k = newdata[i] - newdata[i - 1]
                    
                l = newdata[i + 1] - newdata[i]
                val = a * k + b * l
                
                if second == previous_second + 2 and i != 0:
                    val2 = newdata[i] - newdata[i - 1]
                    ibi += [val2]
                ibi += [val]    
                i += 1
                
        else: # this means we are on the last beat 
            if second != newdata[i - 1]//1000:
                val = newdata[i] - newdata[i - 1]                
                if second == previous_second + 2 and i != 0:
                    val2 = newdata[i] - newdata[i - 1]
                    ibi += [val2]
#                    new_sheet.write(str(val2) + "\n")
                ibi += [val]
#                new_sheet.write(str(val) + "\n")
            else:
                val = newdata[i]
                ibi += [val]
            break
        
        
    ##########################################################################
    # From here on, change code to match your data         

       
    # average for 5 seconds 
    # replace 5 with the number of seconds you want to average over, if it is different 
    if len(ibi) % 5 == 0: 
        # also replace 5 in this for loop
        for i in range(0,len(ibi),5):
            # add up as many ibi's as you want to average over, and also replace 5 with that number
            final_ibi = (ibi[i] + ibi[i+1] + ibi[i+2] + ibi[i+3] + ibi[i+4])/5
            string_ibi = str(final_ibi) + "\n"
            new_sheet.write(string_ibi)
            
    # if it's not divisible by 5, then get rid of the last piece of data 
    # replace 5 in here as well 
    else:
        b = len(ibi) % 5
        for i in range (0, len(ibi)-b, 5):
            final_ibi = (ibi[i] + ibi[i+1] + ibi[i+2] + ibi[i+3] + ibi[i+4])/5
            string_ibi = str(final_ibi) + "\n"
            new_sheet.write(string_ibi)
    new_sheet.close()



##############################################################################
# Program Code


import glob
# CHANGE THIS TO YOUR DIRECTORY 
path = '/Users/Oana/Desktop/IBI Series Materials/Resample'
# Make sure there are no other .xlxs files in the folder except for your data file
filenames = glob.glob(path + '/*.xlsx')

for filename in filenames:
    
    from xlrd import open_workbook
    
    wb = open_workbook(filename)
    # open the IBI series sheet
    
    # create a list of all the sheets in the excel file 
    # CHANGE THIS TO YOUR ID LIST 
    sheets = [201, 202, 203, 204, 205, 206, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220,
          221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 
          239, 240, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255, 256, 257, 258, 
          259, 260, 261, 262, 263, 264, 265, 266, 267, 268, 269, 270, 271, 272, 273, 274, 275, 276,
          277, 278, 279, 280, 281, 282, 283, 284, 285, 286, 287, 288, 289, 290, 291, 292, 295, 296,
          297, 298, 299, 300, 301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312, 313, 314,
          315, 316, 317, 318, 319, 320, 321, 322, 323, 324, 325, 326]


    for page in sheets:
        # CHANGE THIS TO THE NUMBER OF TIME POINT YOU HAVE 
        # Here we have 36 time points, but you see 37 because Python excludes the last number
        # in an interval 
        for i in range(1,37):
            sheet = wb.sheet_by_name(str(page))
            ibi_list = []
            take_excel(i, ibi_list)
            remove_empty(ibi_list)
            turn_to_integer(ibi_list)
            downsample(ibi_list, i, str(page))
            
            
